// WinScript.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "WinScript.h"
#include "compiler.h"
#include "vm.h"

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX

vm::data vm_data;
vm::vcpu vmachine;
int granularity = 0;

HWND hAppWnd;
HBITMAP hBitmap;
HDC hBackBufferDC;
HBITMAP hOldBitmap;		// SelectObjectŌɖ߂
HPEN hPen;
HPEN hOldPen;

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	ErrorList(HWND, UINT, WPARAM, LPARAM);

// obNobt@prbg}bv̍쐬

void CreateBackBuffer(HWND hWnd)
{
	RECT rect;
	GetClientRect(hWnd, &rect);
	HDC hDC = GetDC(hWnd);
	hBitmap = CreateCompatibleBitmap(hDC, rect.right - rect.left, rect.bottom - rect.left);
	hPen = CreatePen(PS_SOLID, 0, RGB(255, 255, 255));

	hBackBufferDC = CreateCompatibleDC(hDC);
	hOldBitmap = (HBITMAP)SelectObject(hBackBufferDC, hBitmap);
	hOldPen = (HPEN)SelectObject(hBackBufferDC, hPen);

	ReleaseDC(hWnd, hDC);
}

// obNobt@prbg}bv

void DeleteBackBuffer(HWND hWnd)
{
	SelectObject(hBackBufferDC, hOldPen);
	SelectObject(hBackBufferDC, hOldBitmap);
	DeleteObject(hBackBufferDC);
	DeleteObject(hBitmap);
	DeleteObject(hPen);
}

// VXeR[
// bZ[W{bNX
int VmMessageBox(const char *title, const char *message)
{
	return MessageBox(hAppWnd, message, title, MB_OK);
}

// 
void VmMoveTo(int x, int y)
{
	MoveToEx(hBackBufferDC, x, y, NULL);
}

void VmLineTo(int x, int y)
{
	LineTo(hBackBufferDC, x, y);
	InvalidateRect(hAppWnd, 0, FALSE);
}

// Fς
void VmSetColor(int r, int g, int b)
{
	HPEN hNewPen = CreatePen(PS_SOLID, 0, RGB(r, g, b));

	SelectObject(hBackBufferDC, hNewPen);
	DeleteObject(hPen);

	hPen = hNewPen;
}

// ĕ`
void VmRefresh()
{
	InvalidateRect(hAppWnd, 0, FALSE);
}

// XNvgJ

void OpenScript(HWND hWnd)
{
	OPENFILENAME ofn;
	char path[MAX_PATH] = "";

	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.hInstance = hInst;
	ofn.lpstrFilter = "XNvgeLXg(*.txt)\0*.txt\0All files(*.*)\0*.*\0\0";
	ofn.lpstrFile = path;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "txt";
	if (GetOpenFileName(&ofn)) {
		// RpC
		vm_data.clear();
		compiler driver;
		if (driver.compile(ofn.lpstrFile, vm_data)) {
			vmachine.init(vm_data);
		}
		else {
			DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_ERRORLIST), hWnd, ErrorList, (LPARAM)&driver);
		}
	}
}


int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;
	HACCEL hAccelTable;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WINSCRIPT, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_WINSCRIPT));

	// C bZ[W [v:
	for (;;) {
		while (vmachine.alive() && !PeekMessage(&msg, 0, 0, 0, PM_NOREMOVE)) {
			vmachine.step(granularity);
		}

		if (!GetMessage(&msg, 0, 0, 0))
			break;
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_WINSCRIPT));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_WINSCRIPT);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   const DWORD style = WS_OVERLAPPED | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU;
   RECT rect = { 0, 0, 640, 480 };
   AdjustWindowRect(&rect, style, TRUE);
   hWnd = CreateWindow(szWindowClass, szTitle, style,
      CW_USEDEFAULT, CW_USEDEFAULT,
	  rect.right - rect.left, rect.bottom - rect.top,
	  NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

	hAppWnd = hWnd;

   return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case ID_OPEN:
			OpenScript(hWnd);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		case IDC_GRANULARITY_0:
			granularity = 0;
			break;

		case IDC_GRANULARITY_10:
			granularity = 10;
			break;

		case IDC_GRANULARITY_100:
			granularity = 100;
			break;

		case IDC_GRANULARITY_1000:
			granularity = 1000;
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_INITMENUPOPUP:
		if (HIWORD(lParam) == 0) {
			int indexMax = GetMenuItemCount((HMENU)wParam);
			for (int index=0; index < indexMax; index++) {
				UINT id = GetMenuItemID((HMENU)wParam, index);
				switch (id) {
				case IDC_GRANULARITY_0:
					CheckMenuItem((HMENU)wParam, id, (granularity == 0? MF_CHECKED: MF_UNCHECKED));
					break;
				case IDC_GRANULARITY_10:
					CheckMenuItem((HMENU)wParam, id, (granularity == 10? MF_CHECKED: MF_UNCHECKED));
					break;
				case IDC_GRANULARITY_100:
					CheckMenuItem((HMENU)wParam, id, (granularity == 100? MF_CHECKED: MF_UNCHECKED));
					break;
				case IDC_GRANULARITY_1000:
					CheckMenuItem((HMENU)wParam, id, (granularity == 1000? MF_CHECKED: MF_UNCHECKED));
					break;
				}
			}
		}
		break;

	case WM_CREATE:
		CreateBackBuffer(hWnd);
		break;

	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		BitBlt(hdc,
			ps.rcPaint.left, ps.rcPaint.top,
			ps.rcPaint.right - ps.rcPaint.left, ps.rcPaint.bottom - ps.rcPaint.top,
			hBackBufferDC, ps.rcPaint.left, ps.rcPaint.top, SRCCOPY);
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		DeleteBackBuffer(hWnd);
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

// G[bZ[W̃bZ[W nhłB
INT_PTR CALLBACK ErrorList(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
	case WM_INITDIALOG:
		{
			compiler *driver = (compiler *)lParam;
			int nerror = min(driver->error_message_size(), 100);	// 100ɐ

			for (int i=0; i<nerror; i++) {
				SendDlgItemMessage(hDlg, IDC_LISTBOX, LB_ADDSTRING,
					0, (LPARAM)driver->error_message(i).c_str());
			}
		}
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) {
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
