// WinScript.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "WinScript.h"
#include "compiler.h"
#include "vm.h"

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX

vm::data vm_data;
vm::vcpu vmachine;

HWND hAppWnd;
HPEN hPen;
HPEN hOldPen;

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	ErrorList(HWND, UINT, WPARAM, LPARAM);

// VXeR[
// bZ[W{bNX
int VmMessageBox(const char *title, const char *message)
{
	return MessageBox(hAppWnd, message, title, MB_OK);
}

// 
void VmMoveTo(int dc, int x, int y)
{
	MoveToEx((HDC)(INT_PTR)dc, x, y, NULL);
}

void VmLineTo(int dc, int x, int y)
{
	LineTo((HDC)(INT_PTR)dc, x, y);
}

// Fς
void VmSetColor(int dc, int r, int g, int b)
{
	HPEN hNewPen = CreatePen(PS_SOLID, 0, RGB(r, g, b));

	SelectObject((HDC)(INT_PTR)dc, hNewPen);
	DeleteObject(hPen);

	hPen = hNewPen;
}

int VmGetDC()
{
	HDC hdc = GetDC(hAppWnd);
	hPen = CreatePen(PS_SOLID, 0, RGB(0, 0, 0));
	hOldPen = (HPEN)SelectObject(hdc, hPen);
	return (int)(INT_PTR)hdc;
}

void VmReleaseDC(int dc)
{
	HDC hdc = (HDC)(INT_PTR)dc;
	SelectObject(hdc, hOldPen);
	ReleaseDC(hAppWnd, hdc);
	DeleteObject(hPen);
}

// RpC
bool Compile(const char *path)
{
	compiler driver;
	// VXeR[̐ݒ
	driver.add_function(vm::SYS_TOSTR, TYPE_STRING, "str", "i");
	driver.add_function(vm::SYS_MESSAGE_BOX, TYPE_INTEGER, "MessageBox", "ss");
	driver.add_function(vm::SYS_LINE_TO, TYPE_VOID, "LineTo", "iii");
	driver.add_function(vm::SYS_MOVE_TO, TYPE_VOID, "MoveTo", "iii");
	driver.add_function(vm::SYS_SET_COLOR, TYPE_VOID, "SetColor", "iiii");
	driver.add_function(vm::SYS_GET_DC, TYPE_INTEGER, "GetDC", "");
	driver.add_function(vm::SYS_RELEASE_DC, TYPE_VOID, "ReleaseDC", "i");

	if (!driver.compile(path, vm_data)) {
		DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_ERRORLIST), NULL, ErrorList, (LPARAM)&driver);
		return false;
	}
	return true;
}


int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;
	HACCEL hAccelTable;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WINSCRIPT, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	if (!Compile("main.txt")) {
		return FALSE;
	}

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_WINSCRIPT));

	// C bZ[W [v:
	while (GetMessage(&msg, 0, 0, 0)) {
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_WINSCRIPT));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_WINSCRIPT);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   const DWORD style = WS_OVERLAPPED | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU;
   RECT rect = { 0, 0, 640, 480 };
   AdjustWindowRect(&rect, style, TRUE);
   hWnd = CreateWindow(szWindowClass, szTitle, style,
      CW_USEDEFAULT, CW_USEDEFAULT,
	  rect.right - rect.left, rect.bottom - rect.top,
	  NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

	hAppWnd = hWnd;

   return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;

	case WM_CREATE:
		vmachine.call(vm_data, vm::data::ON_CREATE);
		break;

	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		hPen = CreatePen(PS_SOLID, 0, RGB(0, 0, 0));
		hOldPen = (HPEN)SelectObject(hdc, hPen);
		vmachine.call(vm_data, vm::data::ON_PAINT, (int)(INT_PTR)hdc);
		SelectObject(hdc, hOldPen);
		DeleteObject(hPen);
		EndPaint(hWnd, &ps);
		break;

	case WM_DESTROY:
		vmachine.call(vm_data, vm::data::ON_DESTROY);
		PostQuitMessage(0);
		break;

	case WM_LBUTTONDOWN:
		SetCapture(hWnd);
		vmachine.call(vm_data, vm::data::ON_LBUTTONDOWN, (short)LOWORD(lParam), (short)HIWORD(lParam));
		break;

	case WM_LBUTTONUP:
		ReleaseCapture();
		vmachine.call(vm_data, vm::data::ON_LBUTTONUP, (short)LOWORD(lParam), (short)HIWORD(lParam));
		break;

	case WM_MOUSEMOVE:
		vmachine.call(vm_data, vm::data::ON_MOUSEMOVE, (short)LOWORD(lParam), (short)HIWORD(lParam));
		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

// G[bZ[W̃bZ[W nhłB
INT_PTR CALLBACK ErrorList(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
	case WM_INITDIALOG:
		{
			compiler *driver = (compiler *)lParam;
			int nerror = min(driver->error_message_size(), 100);	// 100ɐ

			for (int i=0; i<nerror; i++) {
				SendDlgItemMessage(hDlg, IDC_LISTBOX, LB_ADDSTRING,
					0, (LPARAM)driver->error_message(i).c_str());
			}
		}
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) {
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
